if (!("finalizeConstruction" in ViewPU.prototype)) {
    Reflect.set(ViewPU.prototype, "finalizeConstruction", () => { });
}
interface CustomLayout_Params {
    builder?: () => void;
    startSize?: number;
    result?: SizeResult;
}
interface Index_Params {
}
class Index extends ViewPU {
    constructor(parent, params, __localStorage, elmtId = -1, paramsLambda = undefined, extraInfo) {
        super(parent, __localStorage, elmtId, extraInfo);
        if (typeof paramsLambda === "function") {
            this.paramsGenerator_ = paramsLambda;
        }
        this.setInitiallyProvidedValue(params);
        this.finalizeConstruction();
    }
    setInitiallyProvidedValue(params: Index_Params) {
    }
    updateStateVars(params: Index_Params) {
    }
    purgeVariableDependenciesOnElmtId(rmElmtId) {
    }
    aboutToBeDeleted() {
        SubscriberManager.Get().delete(this.id__());
        this.aboutToBeDeletedInternal();
    }
    initialRender() {
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Column.create();
            Column.debugLine("entry/src/main/ets/pages/Page.ets(6:5)");
        }, Column);
        {
            this.observeComponentCreation2((elmtId, isInitialRender) => {
                if (isInitialRender) {
                    let componentCall = new CustomLayout(this, { builder: ColumnChildren }, undefined, elmtId, () => { }, { page: "entry/src/main/ets/pages/Page.ets", line: 7 });
                    ViewPU.create(componentCall);
                    let paramsLambda = () => {
                        return {
                            builder: ColumnChildren
                        };
                    };
                    componentCall.paramsGenerator_ = paramsLambda;
                }
                else {
                    this.updateStateVarsOfChildByElmtId(elmtId, {});
                }
            }, { name: "CustomLayout" });
        }
        Column.pop();
    }
    rerender() {
        this.updateDirtyElements();
    }
    static getEntryName(): string {
        return "Index";
    }
}
// 通过builder的方式传递多个组件，作为自定义组件的一级子组件（即不包含容器组件，如Column）
function ColumnChildren(parent = null) {
    (parent ? parent : this).observeComponentCreation2((elmtId, isInitialRender) => {
        ForEach.create();
        const forEachItemGenFunction = _item => {
            const index = _item;
            (parent ? parent : this).observeComponentCreation2((elmtId, isInitialRender) => {
                Text.create('S' + index);
                Text.debugLine("entry/src/main/ets/pages/Page.ets(16:5)");
                Text.fontSize(30);
                Text.width(100);
                Text.height(100);
                Text.borderWidth(2);
                Text.offset({ x: 10, y: 20 });
            }, Text);
            Text.pop();
        };
        (parent ? parent : this).forEachUpdateFunction(elmtId, [1, 2, 3], forEachItemGenFunction);
    }, ForEach);
    ForEach.pop();
}
class CustomLayout extends ViewPU {
    constructor(parent, params, __localStorage, elmtId = -1, paramsLambda = undefined, extraInfo) {
        super(parent, __localStorage, elmtId, extraInfo);
        if (typeof paramsLambda === "function") {
            this.paramsGenerator_ = paramsLambda;
        }
        this.builder = this.doNothingBuilder;
        this.__startSize = new ObservedPropertySimplePU(100, this, "startSize");
        this.result = {
            width: 0,
            height: 0
        };
        this.setInitiallyProvidedValue(params);
        this.finalizeConstruction();
    }
    setInitiallyProvidedValue(params: CustomLayout_Params) {
        if (params.builder !== undefined) {
            this.builder = params.builder;
        }
        if (params.startSize !== undefined) {
            this.startSize = params.startSize;
        }
        if (params.result !== undefined) {
            this.result = params.result;
        }
    }
    updateStateVars(params: CustomLayout_Params) {
    }
    purgeVariableDependenciesOnElmtId(rmElmtId) {
        this.__startSize.purgeDependencyOnElmtId(rmElmtId);
    }
    aboutToBeDeleted() {
        this.__startSize.aboutToBeDeleted();
        SubscriberManager.Get().delete(this.id__());
        this.aboutToBeDeletedInternal();
    }
    doNothingBuilder(parent = null) {
    }
    private __builder;
    private __startSize: ObservedPropertySimplePU<number>;
    get startSize() {
        return this.__startSize.get();
    }
    set startSize(newValue: number) {
        this.__startSize.set(newValue);
    }
    private result: SizeResult;
    // 第一步：计算各子组件的大小
    onMeasureSize(selfLayoutInfo: GeometryInfo, children: Array<Measurable>, constraint: ConstraintSizeOptions) {
        let size = 100;
        children.forEach((child) => {
            let result: MeasureResult = child.measure({ minHeight: size, minWidth: size, maxWidth: size, maxHeight: size });
            size += result.width / 2;
        });
        this.result.width = 100;
        this.result.height = 400;
        return this.result;
    }
    // 第二步：放置各子组件的位置
    onPlaceChildren(selfLayoutInfo: GeometryInfo, children: Array<Layoutable>, constraint: ConstraintSizeOptions) {
        let startPos = 300;
        children.forEach((child) => {
            let pos = startPos - child.measureResult.height;
            child.layout({ x: pos, y: pos });
        });
    }
    initialRender() {
        this.builder.bind(this)(this);
    }
    rerender() {
        this.updateDirtyElements();
    }
}
registerNamedRoute(() => new Index(undefined, {}), "", { bundleName: "com.example.myapplication", moduleName: "entry", pagePath: "pages/Page", pageFullPath: "entry/src/main/ets/pages/Page", integratedHsp: "false" });
