if (!("finalizeConstruction" in ViewPU.prototype)) {
    Reflect.set(ViewPU.prototype, "finalizeConstruction", () => { });
}
interface Child_Params {
    title?: string;
}
interface Third_Params {
    cnt?: number;
    btnColor?: string;
    showChild?: boolean;
    submit?: () => void;
}
import router from "@ohos:router";
import type { BusinessError } from "@ohos:base";
import SonComponent from "@bundle:com.example.myapplication/entry/ets/Components/SonComponent";
class Third extends ViewPU {
    constructor(parent, params, __localStorage, elmtId = -1, paramsLambda = undefined, extraInfo) {
        super(parent, __localStorage, elmtId, extraInfo);
        if (typeof paramsLambda === "function") {
            this.paramsGenerator_ = paramsLambda;
        }
        this.__cnt = new ObservedPropertySimplePU(0, this, "cnt");
        this.__btnColor = new ObservedPropertySimplePU("#FF007DFF", this, "btnColor");
        this.__showChild = new ObservedPropertySimplePU(true, this, "showChild");
        this.submit = () => {
            this.cnt++;
        };
        this.setInitiallyProvidedValue(params);
        this.finalizeConstruction();
    }
    setInitiallyProvidedValue(params: Third_Params) {
        if (params.cnt !== undefined) {
            this.cnt = params.cnt;
        }
        if (params.btnColor !== undefined) {
            this.btnColor = params.btnColor;
        }
        if (params.showChild !== undefined) {
            this.showChild = params.showChild;
        }
        if (params.submit !== undefined) {
            this.submit = params.submit;
        }
    }
    updateStateVars(params: Third_Params) {
    }
    purgeVariableDependenciesOnElmtId(rmElmtId) {
        this.__cnt.purgeDependencyOnElmtId(rmElmtId);
        this.__btnColor.purgeDependencyOnElmtId(rmElmtId);
        this.__showChild.purgeDependencyOnElmtId(rmElmtId);
    }
    aboutToBeDeleted() {
        this.__cnt.aboutToBeDeleted();
        this.__btnColor.aboutToBeDeleted();
        this.__showChild.aboutToBeDeleted();
        SubscriberManager.Get().delete(this.id__());
        this.aboutToBeDeletedInternal();
    }
    private __cnt: ObservedPropertySimplePU<number>;
    get cnt() {
        return this.__cnt.get();
    }
    set cnt(newValue: number) {
        this.__cnt.set(newValue);
    }
    private __btnColor: ObservedPropertySimplePU<string>;
    get btnColor() {
        return this.__btnColor.get();
    }
    set btnColor(newValue: string) {
        this.__btnColor.set(newValue);
    }
    private __showChild: ObservedPropertySimplePU<boolean>;
    get showChild() {
        return this.__showChild.get();
    }
    set showChild(newValue: boolean) {
        this.__showChild.set(newValue);
    }
    private submit: () => void;
    // 只有被@Entry装饰的组件才可以调用页面的生命周期
    onPageShow() {
        console.info('Index onPageShow');
    }
    // 只有被@Entry装饰的组件才可以调用页面的生命周期
    onPageHide() {
        console.info('Index onPageHide');
    }
    // 只有被@Entry装饰的组件才可以调用页面的生命周期
    onBackPress() {
        console.info('Index onBackPress');
        this.btnColor = "#FFEE0606";
        return true; // 返回true表示页面自己处理返回逻辑，不进行页面路由；返回false表示使用默认的路由返回逻辑，不设置返回值按照false处理
    }
    // 组件生命周期
    aboutToAppear() {
        console.info('MyComponent aboutToAppear');
    }
    // 组件生命周期
    onDidBuild() {
        console.info('MyComponent onDidBuild');
    }
    // 组件生命周期
    aboutToDisappear() {
        console.info('MyComponent aboutToDisappear');
    }
    initialRender() {
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Column.create();
            Column.debugLine("entry/src/main/ets/pages/Third.ets(49:5)");
            Column.width('100%');
        }, Column);
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            If.create();
            if (this.showChild) {
                this.ifElseBranchUpdateFunction(0, () => {
                    {
                        this.observeComponentCreation2((elmtId, isInitialRender) => {
                            if (isInitialRender) {
                                let componentCall = new Child(this, {}, undefined, elmtId, () => { }, { page: "entry/src/main/ets/pages/Third.ets", line: 51 });
                                ViewPU.create(componentCall);
                                let paramsLambda = () => {
                                    return {};
                                };
                                componentCall.paramsGenerator_ = paramsLambda;
                            }
                            else {
                                this.updateStateVarsOfChildByElmtId(elmtId, {});
                            }
                        }, { name: "Child" });
                    }
                });
            }
            else {
                this.ifElseBranchUpdateFunction(1, () => {
                });
            }
        }, If);
        If.pop();
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Button.createWithLabel('delete Child');
            Button.debugLine("entry/src/main/ets/pages/Third.ets(54:7)");
            Button.margin(20);
            Button.backgroundColor(this.btnColor);
            Button.onClick(() => {
                this.showChild = false;
            });
        }, Button);
        Button.pop();
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Button.createWithLabel('push to next page');
            Button.debugLine("entry/src/main/ets/pages/Third.ets(61:7)");
            Button.onClick(() => {
                router.pushUrl({ url: 'pages/Page' });
            });
        }, Button);
        Button.pop();
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Text.create(`${this.cnt}`);
            Text.debugLine("entry/src/main/ets/pages/Third.ets(66:7)");
            Text.fontSize(50);
            Text.fontWeight(FontWeight.Bold);
        }, Text);
        Text.pop();
        {
            this.observeComponentCreation2((elmtId, isInitialRender) => {
                if (isInitialRender) {
                    let componentCall = new SonComponent(this, { submitArrow: this.submit }, undefined, elmtId, () => { }, { page: "entry/src/main/ets/pages/Third.ets", line: 70 });
                    ViewPU.create(componentCall);
                    let paramsLambda = () => {
                        return {
                            submitArrow: this.submit
                        };
                    };
                    componentCall.paramsGenerator_ = paramsLambda;
                }
                else {
                    this.updateStateVarsOfChildByElmtId(elmtId, {});
                }
            }, { name: "SonComponent" });
        }
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Button.createWithChild();
            Button.debugLine("entry/src/main/ets/pages/Third.ets(72:7)");
            Button.type(ButtonType.Capsule);
            Button.margin({
                top: 20
            });
            Button.backgroundColor(this.btnColor);
            Button.width('40%');
            Button.height('5%');
            Button.onClick(() => {
                console.info(`Succeeded in clicking the 'Back' button.`);
                try {
                    router.back();
                    console.info('Succeeded in returning to the first page.');
                }
                catch (err) {
                    let code = (err as BusinessError).code;
                    let message = (err as BusinessError).message;
                    console.error(`Failed to return to the first page. Code is ${code}, message is ${message}`);
                }
            });
        }, Button);
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Text.create('Back');
            Text.debugLine("entry/src/main/ets/pages/Third.ets(73:9)");
            Text.fontSize(25);
            Text.fontWeight(FontWeight.Bold);
            Text.fontColor('#fff');
        }, Text);
        Text.pop();
        Button.pop();
        Column.pop();
    }
    rerender() {
        this.updateDirtyElements();
    }
    static getEntryName(): string {
        return "Third";
    }
}
class Child extends ViewPU {
    constructor(parent, params, __localStorage, elmtId = -1, paramsLambda = undefined, extraInfo) {
        super(parent, __localStorage, elmtId, extraInfo);
        if (typeof paramsLambda === "function") {
            this.paramsGenerator_ = paramsLambda;
        }
        this.__title = new ObservedPropertySimplePU('Hello World', this, "title");
        this.setInitiallyProvidedValue(params);
        this.finalizeConstruction();
    }
    setInitiallyProvidedValue(params: Child_Params) {
        if (params.title !== undefined) {
            this.title = params.title;
        }
    }
    updateStateVars(params: Child_Params) {
    }
    purgeVariableDependenciesOnElmtId(rmElmtId) {
        this.__title.purgeDependencyOnElmtId(rmElmtId);
    }
    aboutToBeDeleted() {
        this.__title.aboutToBeDeleted();
        SubscriberManager.Get().delete(this.id__());
        this.aboutToBeDeletedInternal();
    }
    private __title: ObservedPropertySimplePU<string>;
    get title() {
        return this.__title.get();
    }
    set title(newValue: string) {
        this.__title.set(newValue);
    }
    // 组件生命周期
    aboutToDisappear() {
        console.info('[lifeCycle] Child aboutToDisappear');
    }
    // 组件生命周期
    onDidBuild() {
        console.info('[lifeCycle] Child onDidBuild');
    }
    // 组件生命周期
    aboutToAppear() {
        console.info('[lifeCycle] Child aboutToAppear');
    }
    initialRender() {
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Text.create(this.title);
            Text.debugLine("entry/src/main/ets/pages/Third.ets(120:5)");
            Text.fontSize(50);
            Text.margin(20);
            Text.onClick(() => {
                this.title = 'Hello ArkUI';
            });
        }, Text);
        Text.pop();
    }
    rerender() {
        this.updateDirtyElements();
    }
}
registerNamedRoute(() => new Third(undefined, {}), "", { bundleName: "com.example.myapplication", moduleName: "entry", pagePath: "pages/Third", pageFullPath: "entry/src/main/ets/pages/Third", integratedHsp: "false" });
